                 Function FUMILIR(Hpar,Hexd,funct,Nit,CF,CH)
      IMPLICIT REAL*8 (A-H,O-Z)
	parameter(nq=10000)
	character*(*) hpar,CF,CH,hexd,hname*15
	dimension ar(4)
	allocatable Ai(:,:),exd(:,:)
	external funct

	fumilir=-1.
	open(999,file=Hpar,status='old',err=1)
	do i=1,100000
	 read(999,*,err=2,End=2,iostat=iostat) j,hname,ar
      enddo
2     Nt=i-1
      write(*,*)'Nt=',Nt
	open(999,file=Hexd,status='old',err=3)
	read(999,*) Lexd, Nexd
      write(*,*)'Lexd=',Lexd,'Nexd=', Nexd
      allocate(Ai(6,Nt),exd(Lexd,Nexd))
	js=1
	if(Nexd.gt.nq) then
	   n1=nexd/nq
	   n2=nexd-n1*nq
	   je=nq
         do i=1,n1
	      read(999,*,err=4,End=4) exd(1:Lexd,js:je)
	      js=js+nq
	      je=je+nq
         enddo
      endif
	if(js.le.nexd) read(999,*,err=4,End=4) exd(1:Lexd,js:nexd)
	close(999)
      fumilir=fumilim(Ai,Hpar,Nt,exd,Lexd,Nexd,funct,Nit,CF,CH)
	Return
1     write(*,*)'Cannot Open Initial Parameters File ',Hpar
      Return
3     write(*,*)'Cannot Open Experimental Points File ',Hexd
      Return
4     write(*,*)'Wrong Experimental Points File ',Hexd
      write (*,'(99(3f10.3/))')exd
      Return
	           End
        Function FUMILIM(Ai,Hname,Np,exd,Lexd,Nexd,funct,Nit,CF,CH)
!---------------   author: I.N. Silin, upgrade: I.M. Sitnik, 2012

!------------ Np - number of parameters, no upper restriction for this vaLue
!------------ Ai: parameters array  Ai(Np,6) 
!                Ai(i,1) initiaL/final vaLues of parameters(anaLog of common/A/A(100))
!                Ai(i,2) Parameter errors (final) (anaLog of common/SIGMA/SIGMA(100))       
!                Ai(i,3) Correlation factor (final) (anaLog of common/R/R(100))
!                   new definition: now it is maximum of pair correlations,
!                Ai(i,4) Parameter step restrictin  (anaLog of common/pL/pL(100)),
!                parameter fixed, if Ai(i,4)<0, adjusted by FUMILIM, if Ai(i,4)=0 (recommended)
!                Ai(i,5:6) Limits for Ai(i,1) in any order(analog of common/AL/AMN(100)/AU/AMX(100))       
!------------ Hname: names for parameters array (character*(1-15)), dimension array(Np),
!                or name of file with initial data
!                hisq=FUMILIM(Ai,'*',Np,exd,Lexd,Nexd,funct,Nit,CF,CH) means: no parameter names 
!------------ exd: experimentaL points array exd(Lexd,Nexd),
!                     Nexd - number of exp. points,  not limited
!                     Lexd- number of units in one exp. point, Lexd>2  
!------------ funct(x,A,dF): user's Function (shouLd be decLared as EXTERNAL in caLLing program,
!                where x(1:n) - arguments, A(1:Np) - fitted parameters, dF(1:Np) - first derivatives,
!                user is free to define or not each dF(i)
!                if funct(x,A,dF) is Linear respectively each A(i) (poLinomiaL fit),
!                user is free to define nothing in the Ai array
!------------ abs(Nit): maximum aLLowed number of iteration
!------------ CF: '-' - no output, '*' - screen output, other - output file name
!------------ CH: output file with calculated parameters is writing by default
!                    'n' - cancel  writing of any files
!                    'A' - output theor values and ERR for all points to file *.apN, where N=0-9
!                    'b' - the same for bad points to  *.bpN
!                    'c' - theor curve to *.cuN
!                    'h' - chi^2-histogram to *.hiN
!                    'f' - full output for each iteration in CF, by default only 0 and last iteration
!                     each exp. point(Yexp,ERRexp,X[...Xn] by default 
!                    'y' -           (Yexp,ERRexp,Yth,X[...Xn], Lexd>3
!                    'e' -           (Yexp,ERRexp,Yth,ERRth,X[...Xn], Lexd>4
!                     any combination and order of these symbols in CH is possible


      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 ifp,ifp1,mfix,mtn
	character*(*) hname(Np),CF,CH,hnm*15(Np),namf*19
      allocatable mtn(:,:),hiset(:,:),al(:,:,:),rato(:)
!           mtn - param numbers with not defined derivatives for each set
!           hiset - number  of events and chi^2 for each set 
!           al(2,nx,ns) - max/min values of arguments for each set
	common/gLofum/hisqt,Nt,Nf,Nf1,Nfs,ned1,ned2,ip,ip1,ns,nx,ny
!           hisqt - chi^2 restriction, ned1=Nexd,ned2=Lexd
!           ip=LUN for output
!           ns - number of sets, nx - number of arguments
!           Nt,Nf - total and free numbers of parameters
!           Nf1<Nf, if some parameters fixed by FUMILIM
	common/fuminput/hisqmax(4)/fumirs/ie,namf(5)
!	      namf - output file names, ie - number of symbols
      common/fummsb/msb,isb(9)
	common/fumoutput/hisq,iend,iit,akappa,aLambd,nbad
	dimension G(Np),A(Np),dA(Np),R(Np),sgm(Np),pL(Np),pLm(Np)
	dimension ifp(Np),ifp1(Np),mfix(Np),Am(Np*2)
	dimension exd(*),Ai(Np,6),Z(Np*(Np+1)/2),Z0(Np*(Np+1)/2)
	data eps/0.01d0/T/4d0/n2/1/
      EXTERNAL funct

	fumilim=-1.
	ned1=nexd
	ned2=Lexd 
	nitc=abs(Nit)
	Nt=Np
	ip=-1
      IF(CF.ne.'-') then
	   iend=ifumread(CF,CH,Ai,hname,hnm)
	   if(iend.ne.0) Return
	endif    
	iend=initfum(exd,Ai,A,pL,Am,mfix,ifp,funct,nfit,CH) !check initial data
	IF(iend.ne.0) Return
	allocate(al(2,msb+1,ns),rato(ns))
	allocate(mtn(Nfs,ns),hiset(ns,2),stat=ier1)
	if((ier1).ne.0) then
	   write(ip,*)'*** Allocate failed'
	   iend=6
	   Return
      endif
      call fumdrv(A,exd,funct,ifp,mtn,pL,hnm,Am,al)
      NN2=0
      hisqt=1d37
	plm=pL
	DO ifit=0,nfit   ! Cycle with Different Restrictions for chi^2
      iend=0
	if(ifit.ne.0) then
	   pL=plm 
	   hisqt=hisq/ned1*hisqmax(ifit)
	   if(ip.gt.0) write(ip,'(//A11,i2,A23,f5.1,A26)')
     &' Selection', ifit,' of events with chi^2 <',hisqmax(ifit)
     &  ,'*<chi^2> from previous fit'
	endif
      nbk=0
	nsL=0
	hisqo=1d37
      Do iit=0,nitc   !-----Start New Iteration
         do ibk=1,2 
	      call sgzm(exd,funct,Z0,G,A,pL,Am,ifp,mtn,hiset,al)
	      if(hisq.le.hisqo.or.ibk.eq.2) exit
            NN2=0 !Back to previous param.after jump over extremum
	      nbk=nbk+1
            do n=1,Nf
	         i=ifp(n)
		     A(i)=A(i)-dA(i)
	         pL(i)=pL(i)/T
            enddo
         enddo    ! ibk=1,2
	   if(iit.eq.0) hisqm=hisq
	   dhisq=(hisq-hisqo)/hisqo
	   if(dhisq.gt.-5d-7.and.iit.gt.9.and.dhisq.gt.dhisqo) nsL=nsL+1

      do  !------------------------ boundary check
      do  !------------------------ mgconv 

!--------Remove From Z Contribution of Parameters, Fixed due to Bound or Indefinite
         Nf1=0
         nn=0
	   k=0
         do  n=1,Nf
	     i=ifp(n)
	     mn=nn
	     nn=nn+n
           IF(Z0(nn).eq.0d0) then
		    mfix(i)=2
           ELSEIF(G(i).Lt.0) then
 		    If(Am(i+Np).Le.A(i)) mfix(i)=1
	     ELSE
      	    If(A(i).Le.Am(i)) mfix(i)=1
           ENDIF
           IF(mfix(i).eq.0) then
              Nf1=Nf1+1
	        ifp1(Nf1)=i
              do m=1,n
	          mn=mn+1 
                If(mfix(ifp(m)).eq.0) then
		         k=k+1
                   Z(k)=Z0(mn)
                Endif
              enddo
            ENDIF
         enddo ! n=1,Nf
         indef=mgconvm(Z,mfix,ifp1)
	   if(indef.eq.0) exit  ! from mgconv cycle
      enddo  !------------------------ mgconv 

        aLambd=1.D0 !-----Calculate Step to Minimum
        akappa=0
        afix=0   
        memfix=0   
        nn=0
        do n=1,Nf1
	     nL=nn
	     nn=nn+n
	     i=ifp1(n)
	     sgm(i)=sqrt(Z(nn))
	     dAi=0
		 do L=1,n
	         nL=nL+1
               dAi=dAi-G(ifp1(L))*Z(nL)  ! (indm(n,L))
           enddo
	     nL=nL+n
		 do L=n+1,Nf1
               dAi=dAi-G(ifp1(L))*Z(nL)  ! (indm(n,L))
	         nL=nL+L
           enddo
		 dA(i)=dAi
		 akap=abs(dAi)/sgm(i)
		 if(akap.gt.akappa) akappa=akap
	     pLi=pL(i)

           If(dAi.Le.0) then  !---Check for Parameters on Boundary
		    pLi=min(pLi,(A(i)-Am(i)))
           Else
		    pLi=min(pLi,(Am(i+Nt)-A(i)))
           Endif
           If(pLi.Le.0.D0) then
              if(akap.gt.afix) then   
                 afix=akap   
                 memfix=I
              endif
		 Endif   ! End check 	      
	     aLam=pLi/(abs(dAi)+1d-37)
	     if(aLam.lt.aLambd) aLambd=aLam
        enddo   !------------------------ calc. step to minimum
	  if(memfix.eq.0) exit  ! from boundary check cycLe
        mfix(memfix)=1
      enddo   !------------------ boundary check 

!-----Set Exit Mode If Any
      ndf=ned1-Nf1+1
	hndf=hisq/ndf
      IF(Nf1.eq.0) then
	   iend=5
      ELSEIF(akappa.lt.eps) then
	      iend=1
	      if(Nf1.ne.Nf) iend=2
      ELSEIF(iit.ge.nitc) then
	   iend=4
      ELSEIF(nbk.gt.3.or.nsL.gt.9) then
	   iend=3
      ELSEIF(nit.lt.0) then
	   if(hndf.gt.500d0) then
	       iend=3 
	   elseif(hndf.gt.15d0.and.iit.eq.1) then
	       iend=3
	   endif	    
      ENDIF

	IF(ifit.ne.0.and.iend.ne.0.and.iend.ne.4) then
	   If(hisqm.gt.1.05*hisq) then
	      iend=0
	      hisqm=hisq
            hisqt=hisq/ned1*hisqmax(ifit)
	      pL=plm
	      nbk=0
	   Endif
	ENDIF
      hisqo=hisq
	dhisqo=dhisq

      if(ip.gt.0) call MONITm(hnm,A,Ai,sgm,R,mfix,Z0,ifp1,hiset,rato)
      IF(iend.ne.0) exit

	amb=0.25/aLambd !-----Calculate New Corrected Step
      do n=1,Nf
         i=ifp(n)
	   If(mfix(i).eq.0) then
	      if(aLambd.Lt.1d0) then !----  increase pL(i)
	         if(nn2.gt.n2) then
	            reL=abs(dA(i))/pL(i)
                  if(rel.gt.amb) pL(i)=pL(i)*T
               endif
            endif
	      dA(i)=dA(i)*aLambd
	      A(i)=A(i)+dA(i)
         Else
	     mfix(i)=0
	     dA(i)=0
         Endif
      enddo
      NN2=NN2+1

      Enddo ! iit=0, nitc
   
      do i=1,Nt
         Ai(i,1)=A(i)
         Ai(i,2)=sgm(i)
         Ai(i,3)=R(i)
      enddo
	if(ip.ne.0) then
	  i=ifumcomp(CH,'n')
	  if(i.eq.0) call fumsave(Ai,exd,funct,Z,pL,ifp1,CH,hnm,Am,al,mtn)
      endif

	ENDDO  ! ifit

	fumilim=hndf
	hisqmax=0
	deallocate(mtn,hiset,al,rato)
      Return
                End ! Fumilim

                Function ifumread(CF,CH,Ai,hnam1,hnm)
!---------------  author: I.M. Sitnik, 2012
!---------------  read initial parameters from file
      IMPLICIT REAL*8 (A-H,O-Z)
      character*(*)CF,CH,hnam1(Nt),hnm*15(Nt),s*1,namf*19
	character*5 hfum,hfm, idf*17
	common/fuminput/hisqmax(4)/fumirs/ie,namf
	common/gLofum/hisqt,Nt,Nf,Nf1,Nfs,ned1,ned2,ip,ip1,ns,nx,ny
      dimension Ai(Nt,6)
	data hfum/'fumi_'/ientr/0/
	data idf/'Initial Data File'/

	ientr=ientr+1
	ip=6
	IF(CF.ne.'*') then
	   ip=301
	   open(ip,file=CF,err=5,iostat=iostat)
5        if(iostat.ne.0) then
            write(*,*)'***FUMILIM: Wrong Output File Name'
	      ip=6
	   endif
	ENDIF
	write(ip,"(//' Fit',i4,'   by FUMILIM')") ientr
	IF(ientr.eq.1) then 
	   write(ip,*)'    Function value: chi^2/NDF (-1 for Fatal End)'
         write(ip,*)'    NDF=Nexd-Np(free)+1'
	   write(ip,*)'    Kappa: Estimated Distance to Minimum' 
         write(ip,*)'    Lambda: Step Length Modifier'
	ENDIF

      ifumread=0
	namf=' '
	IF(hnam1(1).eq.'*') then
	   lnf=5
	   hfm=hfum
	   if(ientr.le.9) write(hfm(5:5),'(i1)')ientr
         namf(1:5)=hfm 
	   hnm ='---------------'
      ELSE
	   hnm =' '
	   len1=Len(hnam1(1))
	   if(Len1.gt.15) Len1=15
	   do i=1,Len1
	      s=hnam1(1)(i:i)
	      if(s.eq.' '.or.s.eq.'.') exit
         enddo
	   lnf=i-1
	   namf(1:Lnf)=hnam1(1)(1:Lnf) 
         open(999,file=hnam1(1),status='old',err=3,iostat=iostat)
3        if(iostat.ne.0) then
            write(ip,*)'  *No ',idf
	      do i=1,Nt
	         Lenh=Len(hnam1(i))
	         if(Lenh.gt.15) Lenh=15
	         hnm(i)(1:Lenh)=hnam1(i)(1:Lenh)
            enddo
         else
           write(ip,*)idf,': ',hnam1(1)
	     do i=1,Nt
	       read(999,*,err=4,End=4,iostat=iostat)
     *		   j,hnm(i),Ai(i,1),Ai(i,4:6)
4	       if(iostat.ne.0) then
                write(ip,*)'*** Wrong ',idf,', line',i
	          ifumread=6 
                Return
             endif
           enddo
	     read(999,*,End=1,iostat=iostat) hisqmax
1	     close(999)
         endif
	   Do i=1,Nt
	      do j=15,1,-1
               if(hnm(i)(j:j).ne.' ') exit
	         hnm(i)(j:j)='-'
	      enddo	  			       
         Enddo
      ENDIF  
	ie=Lnf+4
	Return
	      End

                Function initfum(exd,Ai,A,pL,Am,mfix,ifp,funct,nfit,CH)
!---------------  author: I.M. Sitnik, 2012
!--------------- check of initial data
      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 ifp,mfix
	character*(*) CH,hu*1
	common/gLofum/hisqt,Nt,Nf,Nf1,Nfs,ned1,ned2,ip,ip1,ns,nx,ny
	common/fuminput/hisqmax(4)/fumnps/nps/fummsb/msb,isb(9)
	dimension exd(ned2*ned1),pL(*),mfix(*),Am(*),ifp(*)
	dimension Ai(Nt,6),A(Nt),dF(Nt),x(ned2-2)

 	initfum=0
      ny=ifumcomp(CH,'y')+3  !----------- check exd-type
	if(ifumcomp(CH,'e').ne.0) ny=5
	nx=ned2-ny+1
	it=ip
	ip1=ifumcomp(CH,'f')
	if(it.le.0) it=6
	nfit=0   ! check chi^2 restrictions
	do i=1,4                  
	   if(hisqmax(i).eq.0d0) exit
	   nfit=i
      enddo

      msb=0
	if(nfit.ne.0) then
	   mm=min(9,nx)    
	   do m=1,mm               
	     write(hu,'(i1)')m
	     if(ifumcomp(CH,hu).ne.0) then
	        msb=msb+1
	        isb(msb)=m
	        if(ip.ne.0) write(ip,
     *'(" Forbiddance to Remove"i2"th Argument Bound Poitns")')m
	     endif
         enddo
      endif

	if(ned2.Lt.3) then
        write(it,"(//' **Wrong Size of Exp.Point, Lexd=',i5)")ned2
        write(it,*)'should be Lexd>2'
	  initfum=6
      endif
	if(ned1.Lt.Nf) then
        write(it,'(//A22,i5,A37)')'**Too Few Exp. Points =',
     &  ned1,'   should be at Least Nexd=N(free)par'
	  initfum=6
      endif
	if(initfum.ne.0) Return

	nps=0
	dF=0
	Nf=0
	A=Ai(1:Nt,1)
	x=exd(ny:ned2)
	h=funct(x,A,dF)
	do i=1,Nt
	   pL(i)=Ai(i,4)
	   IF(pL(i).Lt.0) then
	      mfix(i)=3
         ELSE
		  mfix(i)=0
		  Nf=Nf+1
		  ifp(Nf)=i
	      Am(i)=Ai(i,5)
	      Am(i+Nt)=Ai(i,6)
	      if(Am(i).eq.0d0.and.Am(i+Nt).eq.0d0) then ! check bounds
	         Am(i)=-1d37
	         Am(i+Nt)=1d37
            elseif(Am(i).gt.Am(i+Nt)) then
	         Am(i)=Ai(i,6)
	         Am(i+Nt)=Ai(i,5)
            elseif(Am(i).eq.Am(i+Nt)) then
		    write(it,'(//A18,i5,A21,1pe10.3)')
     &	    '**Wrong Bounds for',i,'th parameter: min=max',Am(i)
		    initfum=6
            endif
	      if(A(i).lt.Am(i).or.A(i).gt.Am(i+Nt)) then !ini-val within bounds?
	         if(A(i).eq.0d0) then
	            A(i)=(Am(i)+Am(i+Nt))/2d0
		     else	  
		        write(it,"(i5'-th initial value out of bounds')")i
		        initfum=6
               endif
            endif
	      if(dF(i).eq.0d0) then  ! check of more than one sets
	         u=-1d-6
	         if(A(i)+u.Le.Am(i)) u=-u
	         A(i)=A(i)+u
	         dF(i)=funct(x,A,dF)-h
	         A(i)=Ai(i,1)
            endif
	      if(dF(i).ne.0d0) nps=nps+1
         ENDIF
	enddo

	ns=1
	ifset=Nf-nps
	if(ifset.ne.0) then
	  ir=exd(ned2)+0.5
	  absr=abs(exd(ned2)-ir)
	  if(absr.gt.1d-9) ifset=0
      endif
	k=-ned2
      do i=1,ned1
	   k=k+ned2
	   if(exd(k+2).le.0) then ! check of positive exp.err
	     write(it,"(' **Incorrect exda-array after',i8,'-th event')")i
	     initfum=6
	     Return
	   endif
	   if(ifset.ne.0.and.nx.gt.1) then   ! find number of sets
	      iset=exd(k+ned2)+0.5	    
	      if(iset.gt.ns) ns=iset
         endif
      enddo
	Nfs=Nf+1
	if(Nf.gt.30) Nfs=31+(Nf-30)/ns
	Return
               End   ! initfum

			  Function ifumcomp(CH,h)
!--------- search of symbol h in string CH
      character*(*) CH, h*1
	n=Len(CH)
	ifumcomp=0
	do i=1,n
	   if(h.eq.CH(i:i)) ifumcomp=1
      enddo
      Return
                End ! ifumcomp

	Subroutine fumdrv(A,exd,fun,ifp,mtn,pL,hnm,Am,al)
!---------------  author: I.M. Sitnik, 2012
!--------------------------- search of derivatives, defined by user
!--------------------------- separation of parameters, corellated with i-set (if any)
!--------------------------- adjust correct parameter step to find 1st derivatives (if any)
!--------------------------- search of exp.point arguments bounds (if any)
!------------------ mtn - matrix for parameters witout derivatives
!------------------ mtn(1,iset) - number of parametrs for set, mtn(2:nset,iset) - parameter numbers for set
!------------------ mta,mtnp - temporary matrixes for parameters with not defined pL
      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 ifp,idra,idrv,mtn,mta,mtnp,mpl,ifls
	common/gLofum/hisqt,Nt,Nf,Nf1,Nfs,ned1,ned2,ip,ip1,ns,nx,ny
      common/fumnps/nps/fummsb/msb,isb(9)
	character*15 hnm(*),frm*80,hnl*2(3),bf1*38,bf2*36
	dimension exd(ned1*ned2),al(2,msb+1,ns),x(nx)
	!             al - argument bounds
      dimension A(*),ifp(*),Am(*),pL(*),dF(Nt),mpl(Nf)
	dimension dF0(Nt),sumf1(Nt),sumf2(Nt),di(Nt),ifls(ns)
	dimension mta(Nfs,ns),mtnp(Nfs,ns),mtn(Nfs,ns)
	dimension idra(Nf),idrv(Nf),plmax(Nf),none(2)
	data bf1/'*Found Hidden Bifurcations in User Fun'/
	data bf2/'*Found Unused Parameters in User Fun'/
	data frm/'(" Free Param.:"i5", User Defined Derivatives:"i5)'/
      data hnl/'  ','* ','**'/
	data pl2di/0.01d0/

	npl=0
      do n=1,Nf
	   i=ifp(n)
	   pli=pL(i)
	   If(pli.eq.0d0) then
	      npl=npl+1
	      mpl(npl)=i
	      plmax(npl)=(Am(i+Nt)-Am(i))/2
	      if(plmax(npl).lt.1d10) then
	         pli=plmax(npl)
	      elseif(A(i).ne.0d0) then
	         pli=A(i)
            else
	         pli=1d0
            endif
         Endif
	   di(i)=abs(pli)*pl2di
      enddo
	    

	DO n=1,msb    ! search of restriction to remove bad points
	   al(1,n,1:ns)=1d36
	   al(2,n,1:ns)=-1d36
      ENDDO

	nev=ned1
	if(ns.eq.1.and.msb.eq.0.and.npl.eq.0) nev=1
      DO i2=1,2 
         iset=1
	   ifls=0
         Do n=1,Nf
	      i=ifp(n)
            sumf1(i)=0
	      sumf2(i)=0
	      dF(i)=0
	      idrv(n)=0  ! all derivatives
	      idra(n)=0  ! user defined
	   Enddo	   
	   k=-ned2
	   Do i=1,nev            ! events
	      k=k+ned2
	      if(ns.ne.1) iset=exd(k+ned2)+0.5d0
	      x=exd(k+ny:k+ned2)
	      Do n=1,msb   ! search of min/max of arguments
		     m=isb(n)              
	         if(x(m).lt.al(1,n,iset)) al(1,n,iset)=x(m)
	         if(x(m).gt.al(2,n,iset)) al(2,n,iset)=x(m)
            Enddo
	      IF(ifls(iset).eq.0.or.i2.eq.2) then
	         If(ifls(iset).eq.0) then
	            ifls(iset)=1
	            ma=1
	            mn=1
	            mnp=1
               Endif
               h=fun(x,A,dF)
   	         do n=1,Nf
	            If(idrv(n).eq.0.or.i2.eq.1) then
	               j=ifp(n)
	               if(dF(j).ne.0d0) then     ! analytic derivative
	                  dF(j)=0d0
	                  idrv(n)=1
	                  idra(n)=1
	                  if(pL(j).eq.0d0) then
	                     ma=ma+1
	                     mta(ma,iset)=j
                        endif
                     else         ! numerical derivative
	                  Amem=A(j)
	                  A(j)=Amem+di(j) 
                        h1=fun(x,A,dF0)-h
	                  if(h1.ne.0d0) then
	                     idrv(n)=1
                           mn=mn+1
	                     mtn(mn,iset)=j
	                     if(pL(j).eq.0d0) then
	                        mnp=mnp+1
	                        mtnp(mnp,iset)=j
                           endif
                        endif 
	                  A(j)=Amem
                     endif
                  Endif
               enddo
	         mta(1,iset)=ma-1
	         mtn(1,iset)=mn-1
	         mtnp(1,iset)=mnp-1
            ENDIF

	      IF(npl.ne.0) then
               h=fun(x,A,dF)
	         do n=1,mta(1,iset)     ! analytic derivatives
	            j=mta(n+1,iset)
                  Amem=A(j)
	            d=di(j)
                  A(j)=Amem+d
		        h1=fun(x,A,dF0)-h
	            f1=dF(j)
			    f2=2d0*(h1-f1*d)/d**2   ! second derivative	            
	            sumf1(j)=sumf1(j)+abs(f1)
	            sumf2(j)=sumf2(j)+abs(f2)
                  A(j)=Amem
	            dF(j)=0
               enddo
	         do n=1,mtnp(1,iset)      ! numerical derivatives
	            j=mtnp(n+1,iset)
                  Amem=A(j)
	            d=di(j)
                  A(j)=Amem+d
		        h1=fun(x,A,dF0)-h
                  A(j)=A(j)+d
                  h2=fun(x,A,dF0)-h
                  f1=0.5d0*(4*h1-h2)/d  ! first derivative
	            f2=(h2-2*h1)/d**2     ! second derivative
	            sumf1(j)=sumf1(j)+abs(f1)
	            sumf2(j)=sumf2(j)+abs(f2)
                  A(j)=Amem
               enddo
	      ENDIF
         Enddo  ! events

	   ndrv=Nf
	   do n=1,Nf
	      ndrv=ndrv-idrv(n)
         enddo
	   none(i2)=ndrv
	   if(none(i2).eq.0) exit
	   nev=ned1
      ENDDO   !i2=1,2
      ndra=0
	do n=1,Nf
	   ndra=ndra+idra(n)
      enddo
      if(ip.gt.0) then
	   write(ip,"(' Exp.Points:'i9)") ned1
	   write(ip,frm)Nf,ndra
	   if(none(1).ne.0) write(ip,'(A38)') bf1
	   if(none(2).ne.0) write(ip,'(A36)') bf2
	   if(ns.ne.1) then
            write(ip,"(' sets:'i5',  Free Param./set:'i5)")ns,nps
         endif 
      endif 

      IF(npl.gt.0) then   ! adjusting pL
	   plmin=1d9
         do n=1,npl
            j=mpl(n)
		  pli=di(j)/pl2di
		  plf=0.7*sumf1(j)/(sumf2(j)+1d-37)
	      if(plf.lt.plmin) plmin=plf
		  pli=min(2*pli,plf,plmax(n))
	      if(pli.eq.0d0) pli=1d0
	      pL(j)=pli
         enddo
	   do n=1,npl
	      i=mpl(n)
	      plr=min(plmax(n),plmin)
	      if(pL(i).lt.plr) pL(i)=plr
         enddo
	   if(ip.gt.0) then
	     write(ip,"(/' Adjusted Parameter Step Restriction')")
	     if(ip1.gt.0) then ! each iteration print
	       write(ip,"(' High Nonlinear Parameters are Marked')")
		   write(ip,"(25x'initial'5x'final'7x'ratio')")
             do n=1,npl
              j=mpl(n)
		    pli=di(j)/pl2di
		    R=pL(j)/pli
	        m=1
		    if(R.lt.0.1d0) m=2
		    if(R.lt.0.01d0) m=3
		   write(ip,"(i5,a16,1p3e12.3,a5)")j,hnm(j),pli,pL(j),R,hnl(m)
            enddo
	    endif
	  endif
	ENDIF
      Return
                End ! Fumdrv
 
          Subroutine SGZm(exd,funct,Z,G,A,pL,Am,ifp,mtn,hiset,al)
!---------------   author: I.N. Silin, upgrade: I.M. Sitnik, 2012
!-----Find Chi^2,G(Gradient) and Z(Approximate Covariance Matrix)
      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 ifp,mtn
	common/fumoutput/hisq,iend,iit,akappa,aLambd,nbad
	common/gLofum/hisqt,Nt,Nf,Nf1,Nfs,ned1,ned2,ip,ip1,ns,nx,ny
	common/fummsb/msb,isb(9)
	dimension Z(*),G(*),A(*),pL(*),ifp(*),Am(*)
      dimension dF(Nt),dfn(Nt),dF0(Nt),d(Nt),mtn(Nfs,ns),x(nx)
	dimension exd(ned1*ned2),hiset(ns*2),al(2,msb+1,ns)

      hisq=0
	nbad=0
	hiset=0
      Nz=Nf*(Nf+1)/2
	Z(1:Nz)=0
	  
	do i=1,Nt
         G(i)=0
	   dF(i)=0
         u=-0.01d0*pL(i)
	   if((A(i)+u).le.Am(i)) u=-u
	   d(i)=u
      enddo

      k=-ned2
	iset=1
      DO L1=1,ned1
         k=k+ned2
	   x=exd(k+ny:k+ned2)
         y=funct(x,A,dF)
	   if(ns.ne.1) iset=x(nx)+0.5d0 
         sig=exd(k+2)
         dysig=(Y-exd(k+1))/sig
	   hisqi=dysig**2+1d-36
	   mem=0
         if(hisqi.gt.hisqt) then
	      mem=1
		  Do n=1,msb
	         m=isb(n) 
	         if(x(m).eq.al(1,n,iset).or.x(m).eq.al(2,n,iset)) mem=0
	      Enddo
         endif
	   If(mem.ne.0) then
	      nbad=nbad+1
         else
            hisq=hisq+hisqi
	      hiset(iset)=hiset(iset)+1d0
	      hiset(iset+ns)=hiset(iset+ns)+hisqi
	      if(ny.gt.3) exd(k+3)=y
	      Do n=1,mtn(1,iset)
	         i=mtn(n+1,iset)
               Amem=A(i)
               A(i)=Amem+d(i)
		     dF(i)=(funct(x,A,dF0)-Y)/d(i)
               A(i)=Amem
            Enddo
            L=0
            Do n=1,Nf
		     i=ifp(n)
		     if(dF(i).eq.0d0) then
		        dFn(n)=0
		     else
                  dFt=dF(i)/SIG
                  dFn(N)=dFt
                  G(i)=G(i)+dFt*dysig
		        do j=1,n
                     Z(L+j)=Z(L+j)+dFt*dFn(j)
                  enddo
		        dF(i)=0
		     endif
	         L=L+n
	      Enddo
         Endif  ! mem.ne.0
      ENDDO !  L1=1,ned1
      Return
               End        ! sgzm


               Function mgconvm(Z,mfix,ifp1)
!---------------   author: I.N. Silin, upgrade: I.M. Sitnik, 2012
!----------  Z-matrix transformation
      IMPLICIT REAL*8 (A-H,O-Z)
	parameter(ap=1d-37)
 	integer*2 ifp1,mfix
	common/gLofum/hisqt,Nt,Nf,N,ned1,ned2,ip,ip1,ns,nx,ny
	dimension Z(*),mfix(*),ifp1(*),km(N),ind1i(N),indii(N)

      mgconvm=0
	if(N.eq.0) Return
	apn=ap*n
	aps=sqrt(1d0/apn)

	m=1
      DO I=1,N
 	  ind1i(i)=m
        m=m+i
	  indii(i)=m-1
      ENDDO
	nn=indii(n)-n

      DO j=1,n
        t0=1d37
        kk=0
	  i=j
        Do k=j,n     ! find k with min{max[zkl/sqrt(zkk)]} 
            zklmx=0.
            kk=kk+k
	      t2=Z(kk)
		  If(t2.gt.apn) then
               sqzkk=sqrt(t2)
	         kL=indii(k)-k+j
               do L=j+1,k-1
	            kL=kL+1 
	            t=abs(Z(kL))
                  if(t.gt.zklmx) zklmx=t
               enddo
	         kL=indii(k)+k
               do L=k+1,n
	            t=abs(Z(kL))
                  if(t.gt.zklmx) zklmx=t
	            kL=kL+L
               enddo
	         t=zklmx/sqzkk
               if(t.Lt.t0) then
	           t0=t
                 i=k
               endif
            Endif
        Enddo ! k=j,n
        km(j)=i

        if(i.ne.j) then ! exchange i-th and j-th string of matrix
          ii=indii(i)
          jj=indii(j)
          sav=Z(ii)
	    Z(ii)=Z(jj)
          Z(jj)=sav
	    ki=ind1i(i)
	    kj=ind1i(j)
          do k=1,j-1
             sav=Z(ki)
             Z(ki)=Z(kj)
             Z(kj)=sav
	       ki=ki+1
	       kj=kj+1
          enddo ! k=1,n
          kj=kj+J
          do k=j+1,i-1
	       ki=ki+1
             sav=Z(ki)
             Z(ki)=Z(kj)
             Z(kj)=sav
	       kj=kj+k
          enddo ! k=1,n
          kj=kj+i
          ki=ki+i+1
          do k=i+1,n
             sav=Z(ki)
             Z(ki)=Z(kj)
             Z(kj)=sav
	       ki=ki+k
	       kj=kj+k
          enddo ! k=1,n
 
        endif ! i.ne.j
        i=j
        ii=indii(i)

        IF(Z(ii).Le.apn) then
          Z(ii)=apn
          mfix(ifp1(km(i)))=2
	    mgconvm=1
        ENDIF
        Z(ii)=1./sqrt(Z(ii))
        arp=aps/Z(ii)
        Zm=1.
	  iL=ind1i(i)
        Do L=1,i-1
           ZiL=ABS(Z(iL))
           If(ZiL.gt.arp) then
		    dm=arp/ZiL
              if(Zm.gt.dm) Zm=dm
           Endif
	     iL=iL+1
        Enddo
	  iL=iL+i
        Do L=i+1,N
           ZiL=abs(Z(iL))
           If(ZiL.gt.arp) then
		    dm=arp/ZiL
              if(Zm.gt.dm) Zm=dm
           Endif
	     iL=iL+L
        Enddo

        Zii=Z(ii)*Zm
        Z(ii)=Zii
	  iL=nn+i
        Do L=n,i+1,-1
           Z(iL)=Z(iL)*Zii
	     iL=iL-L+1
        Enddo
        Do L=i-1,1,-1
	     iL=iL-1
           Z(iL)=Z(iL)*Zii
        Enddo 
	  ki=nn+i
	  Do k=n,i+1,-1
          Zki=Z(Ki) 
	    Lk=indii(k)
	    Li=Lk-k+i
          do L=k,i+1,-1 
             Z(Lk)=Z(Lk)-Z(Li)*Zki
	       Lk=Lk-1
	       Li=Li-L+1
          enddo 
          do L=i,1,-1
             Z(Lk)=Z(Lk)-Z(Li)*Zki
	       Lk=Lk-1
	       Li=Li-1
          enddo
          Z(Ki)=-Zki*Zii
          ki=ki-k+1
        Enddo ! k=n,i+1,-1
      ENDDO ! j=1,n

      DO I=1,N
	   ii=indii(i)
         D=Z(ii)**2
	   Li=ii+i
	   ki=Li
         Do L=I+1,n
            D=D+Z(Li)**2
	      Li=Li+L
         Enddo
         Z(ii)=D
         Do K=I+1,n
	      kk=indii(k) 
            D=Z(ki)*Z(kk)
	      Lk=kk+k
	      Li=ki+k
            do L=k+1,n
               D=D+Z(Li)*Z(Lk)
	         Lk=Lk+L
	         Li=Li+L
            enddo
            Z(ki)=D
            ki=ki+k
         Enddo ! k=i+1,n
      ENDDO ! i=1,n  

      DO i=n,1,-1
        j=km(i)
        if(j.ne.i) then ! Back Exchange i-th and j-th strings of matrix
           ii=indii(i)
           jj=indii(j)
	     sav=Z(ii)
           Z(ii)=Z(jj)
           Z(jj)=sav

           ki=ind1i(i)
           kj=ind1i(j)
	     Do k=1,i-1
              zki=Z(ki)
              Z(ki)=Z(kj)
	        Z(kj)=zki
	        ki=ki+1
	        kj=kj+1
           Enddo ! k=1,n
           ki=ki+i
           Do k=i+1,j-1
              kj=kj+1 
              zki=Z(ki)
              Z(ki)=Z(kj)
	        Z(kj)=zki
              ki=ki+k 
           Enddo ! k=1,n
           ki=ki+j
	     kj=kj+j+1 
           Do k=j+1,n
              zki=Z(ki)
              Z(ki)=Z(kj)
	        Z(kj)=zki
	        ki=ki+k
	        kj=kj+k
           Enddo ! k=1,n
        endif ! j.ne.i
      ENDDO ! i=n,1,-1

      Return
                End

      Subroutine MONITm(hoL,A,Ai,sgm,R,mfix,Z,ifp1,hiset,rato)
!---------------   author: I.N. Silin, upgrade: I.M. Sitnik, 2012
!-----Iteration Progress Output
      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 ifp1,mfix
	common/gLofum/hisqt,Nt,Nf,Nf1,Nfs,ned1,ned2,ip,ip1,ns,nx,ny
	common/fumoutput/hisq,iend,iit,akp,aLam,nbad
	dimension A(*),Ai(Nt),sgm(*),R(*),ifp1(*)
	dimension mfix(*),ir(Nt),Z(*),hiset(ns,2),rato(*)
	character*(*) hoL(Nt),zv*4,zvi*2(2),ht*51(5),hrat*1
	character*9 hpar,hpr(2),hdev,hch,hsta*8,hcor*11,hfix*16(3)   
	data hpar/'Parameter'/,hsta/'Standard'/,hcor/'Max.Pair'/
	character*13 hnum,hval*5,hfac*12,hfor*80(3)
	data hnum/'Number & Name'/,hval/'Value'/,hdev/'Deviation'/
	data hfac/'Correl.Fact.'/,hch/'Increment'/
	data ht/' Full Success',
     *' Success When Some Parameters are Fixed by FUMILIM ',
     *' Minimization is Terminated, No Further Convergence',
     *' Minimization is Terminated, Iteration Limit',
     *' Minimization is Terminated, No Free Parameters'/
	data hfix/' Fixed on Bound','  Fixed: dF/dA=0','Fixed by User'/
	data hfor
     */"(I7,a16,1pD14.5,A4,D13.5,D14.5' ('0pf5.1'%)'A3,f8.3,i5,A6)",      
     *"(I7,a16,1pD15.5,A3,d13.5,d14.5' ('0pf5.1'%)'A3,A20)",
     *"(I7,a16,1pD15.5,A3,A20,A19)"/
	data zvi/' ','--'/

      hndf=hisq/(ned1-Nf1+1)
	if(iit.eq.0) then
	   hndf0=hndf
	   hisqold=1d37
	   ratav=hisq/ned1
	   do i=1,ns
	      if(hiset(i,1).ge.0.5)rato(i)=hiset(i,2)/hiset(i,1)
         enddo
      endif
	dhisq=(hisq-hisqold)/hisqold
	hisqold=hisq
	write
     *(ip,'(/A8,I3,A13,1pD12.5,A9,D12.5,A18,D10.3,A13,D9.2,A8,D9.2,A2)')
     *'Iter=',iit,':  chi^2/NDF=',hndf,'chi^2=',hisq,
     *'d(chi^2)/chi^2=',dhisq,'Kappa=',akp,'Lambda=',aLam
	if(nbad.ne.0) then
	  percent=1d2*nbad/ned1
	  write(ip,'(i7"("f4.1"%)"A40)')nbad,percent,
     &  ' events are ignored due to huge chi^2'
	endif
	IF(iend.ne.0.or.ip1.eq.1.or.iit.eq.0) then
	   write(ip,'(/A15,A20,A16,A15,A28)')hpar,hpar,hsta,hpar,hcor
	   write(ip,'(A19,A12,A21,A14,A29/)')hnum,hval,hdev,hch,hfac
         call fumcormax(Z,ifp1,R,ir)
         izv=1
	   DO I=1,Nt
	      izv=3-izv
            ipr=mfix(i)
	      dA=A(i)-Ai(i)
		  den=max(abs(A(i)),abs(Ai(i)))
	      If(den.eq.0d0) then
	          per=0
            Else
		     per=abs(dA)/den*100
            Endif
	      If(ipr.eq.0) then
			 zv='    '
			 if(abs(R(i)).gt.0.9) zv='>0.9'
	         write(ip,hfor(1))I,hoL(i),A(i),zvi(izv),
     *		 sgm(i),dA,per,zvi(izv),R(i),ir(i),zv
	      Elseif(ipr.lt.3) then	 
	         write(ip,hfor(2))I,hoL(i),A(i),zvi(izv),0d0,dA,per,
     *	     zvi(izv),hfix(ipr)
            Else
		    write(ip,hfor(3))I,hoL(i),A(i),zvi(izv),hfix(ipr),zvi(izv)  
            Endif
	   ENDDO
      ENDIF

      IF(iend.eq.0) Return
	write(ip,'(/"Iend=",I2,":",a51/)')iend,ht(iend)
	write(ip,"('chi^2/NDF change:'1pd12.5,' ->'d12.5)")hndf0,hndf
	IF(ns.ne.1) then
	   write(ip,'(/"Exp.points ,<chi^2> change for each set")')
	   rat0=hisq/ned1
         write(ip,'("  All",i9,3x,1pe12.5" ->"e12.5)')ned1,ratav,rat0
	   write(ip,*)
     *   ' + over twice larger, - under twice less, than averege'
	   write(ip,*)

	   do i=1,ns
            if(hiset(i,1).ne.0d0) then
	         ifl=0
	         rat=hiset(i,2)/hiset(i,1)
	         rr=rat/rat0
	         hrat=' '
	         if(rr.le.0.5) hrat='-'
	         if(rr.ge.2.0) hrat='+'
	         n=hiset(i,1)
	         write(ip,'(i5,i9,3x,1pe12.5" ->"e12.5,A2)')
     *		  i,n,rato(i),rat,hrat
	      else
	         if(ifl.eq.0) write(ip,*) '---'
	         ifl=1
            endif 
         enddo
      ENDIF
	Return
               End

               Subroutine fumcormax(Z,ifp,R,icor)
!------------  author: I.M. Sitnik, 2010
!-----Calculate Pair Correlations Between Parameters
      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 ifp
	common/gLofum/hisqt,Nt,Nf,Nf1,Nfs,ned1,ned2,ip,ip1,ns,nx,ny
	dimension Z(*),ifp(*),R(*),icor(*)

	nn=0
      DO n=1,Nf1
	   nn=nn+n
	   mm=0
	   z1=Z(nn)
	   cormax=0
	   mem=0
	   mnn=n*(n-1)/2
	   Do m=1,n-1
	      mn=mnn+m
	      mm=mm+m
	      z2=Z(mn)
	      if(z2.ne.0d0) then
	         r1=z2/sqrt(Z(mm)*z1)
	         if(abs(r1).gt.abs(cormax)) then
	            cormax=r1
	            mem=ifp(m)
	         endif
	      endif
	   Enddo
	   mm=nn
	   mn=n*(n+1)/2+n
	   Do m=n+1,Nf1
	      mm=mm+m
	      z2=Z(mn)
	      mn=mn+m
	      if(z2.ne.0d0) then
	         r1=z2/sqrt(Z(mm)*z1)
	         if(abs(r1).gt.abs(cormax)) then
	            cormax=r1
	            mem=ifp(m)
	         endif
	      endif
         Enddo
	   i=ifp(n)
	   icor(i)=mem
	   R(i)=cormax
      ENDDO
	Return
                End

           Subroutine fumsave(Ai,exd,funct,Z,pL,ifp1,CH,hnam2,Am,al,mtn)
!---------------  author: I.M. Sitnik, 2010
!-----writes output files
!-----*.fpN (fitted parameters) 
!-----*.apN (all points).
!-----*.bpN (bad points)
!-----*.cuN (curve)
!-----*.hiN (chi^2-distribution)

      IMPLICIT REAL*8 (A-H,O-Z)
	parameter(nstep=100)
	integer*2 ifp1,mtn
	character*(*)CH,namf*19,hnam2*15(Nt),s*1,f1*60,f2*25
	common/gLofum/hisqt,Nt,Nf,Nf1,Nfs,ned1,ned2,ip,ip1,ns,nx,ny
	common/fuminput/hisqmax(4)/fumirs/ie,namf/fummsb/msb,isb(9)
	common/fumoutput/hisq,iend,iit,akappa,aLambd,nbad
	common/fumx/x(20),ix
	dimension exd(ned2,ned1),pL(Nt),ifp1(*),dF(Nt),dF0(Nt),d(Nt)
	dimension A(Nt),dfn(Nt),Z(*),Ai(Nt,6),ar(nstep,2),mtn(Nfs,ns)
	dimension al(2,msb+1,ns),xt(nx),Am(*)
	data f2/'(I5,1p4e12.3,2x,19e12.3)'/f1
     */' N       Y_exp       Err_exp     Y_th        Err_th        x'/
!---------------------------
      namf(ie-3:ie)='.fp0'
	do i=0,9
	   write(s,'(i1)')i
         namf(ie:ie)=s
	   open(99,file=namf,status='old',err=5,iostat=iostat)
5        if(iostat.ne.0) exit
      enddo
	if(iostat.eq.0) namf(ie:ie)='_'
	open(99,file=namf)
	do i=1,Nt
	   write(99,'(i6,3x,A15,3x,1p4E13.4)')i,hnam2(i),Ai(i,1),Ai(i,4:6)
      enddo
	if(hisqmax(1).ne.0d0) write(99,'(/4f10.2)')hisqmax
	close(99)
      write(ip,'(/"Fitted Parameters are Saved to  ",a19)')namf
	if(CH.eq.'*') Return
	my=0
	if(ny.eq.5) my=1
      ma=ifumcomp(CH,'a')
	mb=ifumcomp(CH,'b')*nbad
	mh=ifumcomp(CH,'h')
	mc=ifumcomp(CH,'c')
	mab=ma+mb+my
	mabh=mab+mh
	ms=mabh+mc
	if(ms.eq.0) Return
	is=ie-1
	do i=1,Nt
         A(i)=Ai(i,1)
	   dF(i)=0
         u=0.01d0*pL(i)
	   if((A(i)+u).ge.Am(i+Nt)) u=-u
	   d(i)=u
      enddo
	if(nx.eq.1.or.ix.eq.0) ix=1

	blimh=1d-36    
      alimc=1d37
	blimc=-1d37    

      if(mb.ne.0) then
	   namf(is-1:is)='bp'
	   open(99,file=namf)
	   write(99,*) f1
	   write(ip,'("Bad Points are Saved to ",a19)')namf
	endif
      if(ma.ne.0) then
	   namf(is-1:is)='ap'
	   open(98,file=namf)
	   write(98,*) f1
	   write(ip,'("All Points are Saved to ",a19)')namf
	endif

      iset=1
	mx=min(nx,19)

      DO j=1,ned1
	   xt=exd(ny:ned2,j)
         xc=xt(ix)
	   IF(xc.lt.alimc) alimc=xc
	   IF(xc.gt.blimc) blimc=xc
	   IF(mabh.gt.0) then
	      If(ns.ne.1)iset=xt(nx)+0.5
	      y=funct(xt,A,dF)
            If(mab.ne.0) then
	         do n=1,mtn(1,iset)
                  i=mtn(1+n,iset)
                  A(i)=A(i)+d(i)
		        dF(i)=(funct(xt,A,dF0)-Y)/d(i)
                  A(i)=Ai(i,1)
               enddo
	         do n=1,Nf1
	            i=ifp1(n)
	            dfn(n)=dF(i)
	            dF(i)=0
               enddo 
               erf=scaLm(Z,dfn,Nf1)
            Endif  
	      hsq=((exd(1,j)-y)/exd(2,j))**2+1d-36
	      If(hsq.gt.blimh)blimh=hsq
	      If(hsq.gt.hisqt.and.mb.ne.0) then
	        mr=0
	        do n=1,msb
	         m=isb(n)
	         if(xt(m).eq.al(1,n,iset).or.xt(m).eq.al(2,n,iset)) mr=1
	        enddo
              if(mr.eq.0) write(99,f2)j,exd(1:2,j),y,erf,xt(1:mx)
	      Endif
	      If(my.ne.0) exd(4,j)=erf
	      If(ma.ne.0) write(98,f2)j,exd(1:2,j),y,erf,xt(1:mx)
	   ENDIF
      ENDDO
	IF(ma.ne.0) close(98)

      IF(mh.eq.1) then    !----------------- chi^2/<chi^2>
         ar=0
         avh=hisq/ned1
	   namf(is-1:is)='hi'
	   open(99,file=namf)
	   write(99,"(3x'lg(hi^2)     hi^2<max   hi^2>max')") 
	   write(ip,'("lg(hi^2)-histogram is Saved to ",a19)')namf
	   na=-4
	   nb=log10(blimh/avh)+1
	   step=1d0*(nb-na)/(nstep-1)
	   ar=0
         do m=1,ned1
            y=funct(exd(ny,m),A,dF)
	      hsq=((exd(1,m)-y)/exd(2,m))**2+1d-36
	      hsqlog=log10(hsq/avh)-na
	      j=hsqlog/step+1
	      ind=1
	      if(hsq.gt.hisqt) ind=2
	      if(j.gt.0) ar(j,ind)=ar(j,ind)+1d0
         enddo
	   arg=na-0.5d0*step
         do i=1,nstep
	     arg=arg+step
           write(99,'(1p3e12.3)')arg,ar(i,1:2)
	   enddo
      ENDIF
	
	IF(mc.eq.1) then         !------------------- curve 
	   if(x(1).eq.0d0.and.x(2).eq.0d0) x(1:nx)=exd(ny:ned2,1)
	   dlim=(blimc-alimc)*0.01d0
	   alimc=alimc-dlim
	   blimc=blimc+dlim
	   dx=(bLimc-aLimc)/(nstep-1)
	   namf(is-1:is)='cu'
         open(99,file=namf)
	   write(99,"(7x'x             y          y-err       y+err')") 
         write(ip,'("Theor-Curve is Saved to ",a19)')namf
         Do j=1,nstep
	      x(ix)=aLimc+(j-1)*dx
	      y=funct(x,A,dF)
	      do n=1,mtn(1,iset)
               i=mtn(1+n,iset)
               A(i)=A(i)+d(i)
		     dF(i)=(funct(x,A,dF0)-Y)/d(i)
               A(i)=Ai(i,1)
            enddo
	      do n=1,Nf1
	         i=ifp1(n)
	         dfn(n)=dF(i)
	         dF(i)=0
            enddo 
            er=scaLm(Z,dfn,Nf1)
	      dw=y-er
	      up=y+er
	      write(99,'(1pe12.3,3x,3e12.4)')x(ix),y,dw,up
         Enddo
	   x=0
      ENDIF
	close(99)
      Return
                     End

               Function SCALm(Z,dF,n)
!---------------  author: I.N. Silin, upgrade: I.M. Sitnik, 2012
!-----------Calculate Er-Variance of Theoretical Function Y
      IMPLICIT REAL*8 (A-H,O-Z)
	dimension Z(*),dF(n)
 
	dispii=0
	dispij=0
	m=0
      DO I=1,N
	   dfi=dF(i)
	   if(dfi.ne.0d0) then
            Do L=1,I-1
               dispij=dispij+Z(m+L)*dfi*dF(L)
            Enddo
	      dispii=dispii+Z(m+I)*dfi**2
         endif
	   m=m+I
      ENDDO
      scaLm=sqrt(dispii+2*dispij)
      Return
              End

            Function FUMI2par(Ai,exd,Lexd,nexd,fun,Nit)
!---------------  author: I.M. Sitnik, 2012
      IMPLICIT REAL*8 (A-H,O-Z)
      EXTERNAL fun
	common/fumoutput/hisq,iend,iit,akappa,aLambd,nbad
	dimension A(2),pL(2),idr2(2),sgm(2),dA(2),dF(2),hi(2)
	dimension exd(Lexd*nexd),Ai(2,6),ifp(2),dF0(2)
      data eps/0.01d0/T/0.25/n2/1/
      nitc=abs(Nit)
	ned1=nexd
	ned2=Lexd
	Nf=2
	A(1)=Ai(1,1)
	A(2)=Ai(2,1)
	pL(1)=Ai(1,4)
	pL(2)=Ai(2,4)

	dF(1)=0      ! search of user defined derivatives
	dF(2)=0
	ndr2=2         
	h=fun(exd(3),A,dF)
	if(dF(1).ne.0d0) then
	   ndr2=ndr2-1
      else 
         idr2(1)=1
      endif
	if(dF(2).ne.0d0) then
	   ndr2=ndr2-1
      else 
         idr2(ndr2)=2
      endif
!---------------------------- redefinition of pL(i) if any
	   plmin=1d9
	   DO i=1,2
	      If(pL(i).le.0) then
	         d=0.01*abs(A(i))+1d-6
               Amem=A(i)
	         if(dF(i).ne.0) then
                  A(i)=Amem+d
		        h1=fun(exd(3),A,dF0)-h
	            f1=dF(i)
			    f2=2d0*(h1-f1*d)/d**2	            
               else
	            h=fun(exd(3),A,dF0)
	            A(i)=Amem+d
	            h1=fun(exd(3),A,dF0)-h
	            A(i)=A(i)+d
	            h2=fun(exd(3),A,dF0)-h
	            f1=-0.5d0*(h2-4*h1)/d
	            f2=(h2-2d0*h1)/d**2
		     endif
	         pls=0.7*abs(f1/(f2+1d-37))
	         if(pls.lt.plmin) plmin=pls
	         pL(i)=min(200*d,pls)
               A(i)=Amem
            Endif
         ENDDO
	   DO i=1,2
	      if(pL(i).lt.plmin) pL(i)=plmin
         ENDDO

      NN2=0
      iend=0
	hisqo=1d37
      ndf=ned1-1
	nbk=0
      DO iit=0,nitc  !-----Start New Iteration
         do ibk=1,2 !------------------------sgz2 
            k=0 
            hisq=0
	      G1=0
	      G2=0
            Z01=0
            Z02=0
            Z03=0
	      hi(1)=pL(1)*0.01d0
	      hi(2)=pL(2)*0.01d0
            do L=1,ned1
               sig=exd(k+2)
	         y=fun(exd(k+3),A,dF)
               dysig=(Y-exd(k+1))/sig
	         hisq=hisq+dysig**2
	         do n=1,ndr2
	            i=idr2(n)
		        Amem=A(i)
                  A(i)=Amem+hi(i)
		        dF(i)=(fun(exd(k+3),A,dF0)-Y)/hi(i)
                  A(i)=Amem
               enddo
	         df1=dF(1)/sig
	         df2=dF(2)/sig
               G1=G1+df1*dysig
               G2=G2+df2*dysig
               Z01=Z01+df1*df1
               Z02=Z02+df1*df2
               Z03=Z03+df2*df2
               k=k+NED2
            enddo !  L=1,ned1 --------- End sgz2
	      if(hisq.le.hisqo) exit
            NN2=0  ! Back to previous parameters
            do i=1,2
 		     A(i)=A(i)-dA(i)
               pL(i)=pL(i)*T
            enddo
         enddo    ! ibk=1,2 
	   hndf=hisq/ndf
	   dhisq=(hisq-hisqo)/hisqo
	   if(dhisq.gt.-5d-7) nbk=nbk+1

	   if(Z01.Le.0.or.Z03.Le.0) then !----------------  mgconv2           
            fumi2par=-1.
	      write(*,*)'fumi2par: ridiculous event'
	      iend=5
	      Return
         endif 
	   Z02q=Z02**2
         det=Z03-Z02q/Z01
	   if(det.Le.1d-19) det=1d-19
	   Z3=1d0/det
         Z1=1d0/Z01+Z02q/Z01**2*Z3
	   Z2=-Z02/Z01*Z3  !----------  End mgconv2

	   dA(1)=-G1*Z1-G2*Z2 !-----Calculate Step to Minimum
	   dA(2)=-G1*Z2-G2*Z3
	   sgm(1)=sqrt(Z1)
	   sgm(2)=sqrt(Z3)
	   absda1=abs(dA(1))
	   absda2=abs(dA(2))
	   akappa=max(absda1/sgm(1),absda2/sgm(2))
	   AL1=pL(1)/absda1
	   AL2=pL(2)/absda2
	   aLambd=min(1d0,AL1,AL2)
!-----Set Exit Mode If Any
         IF(akappa.Lt.EPS) then !  good finish
	      iend=1
	   ELSEIF(iit.eq.nitc) then
	      iend=4
         ELSEIF(nbk.gt.2) then
            iend=3
         ELSEIF(nit.lt.0) then
	      if(hndf.gt.500d0) then
	         iend=3 
	      elseif(hndf.gt.15d0.and.iit.eq.1) then
	         iend=3
	      endif	    
         ENDIF

         IF(iend.ne.0) exit
         amb4=aLambd*4d0
         IF(NN2.gt.N2) then
	      if(AL1.lt.amb4) pL(1)=pL(1)*4d0
            if(AL2.lt.amb4) pL(2)=pL(2)*4d0
         ENDIF
         dA(1)=dA(1)*aLambd
         dA(2)=dA(2)*aLambd
	   A(1)=A(1)+dA(1)
	   A(2)=A(2)+dA(2)
         hisqo=hisq
         NN2=NN2+1

      ENDDO    !  iit=0, nitc
      do i=1,2
        Ai(i,1)=A(i)
	  Ai(i,2)=sgm(i)
      enddo

      fumi2par=hndf
      Return
                End ! Fumi2par

